int DTerrain <string UIName = "DTerrain";> = 0;

SamplerState textureSampler
{
	Filter = MIN_MAG_MIP_LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

Texture2D blend1Texture : DiffuseMap<string UIName = "blend1Texture"; string ResourceType = "2D"; int Texcoord = 0; int MapChannel = 1;>;
Texture2D blend2Texture : DiffuseMap<string UIName = "blend2Texture"; int Texcoord = 0; int MapChannel = 1;>;
Texture2D map0Texture : DiffuseMap<string UIName = "map0Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map0TextureScale<string UIName = "map0TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map1Texture : DiffuseMap<string UIName = "map1Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map1TextureScale<string UIName = "map1TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map2Texture : DiffuseMap<string UIName = "map2Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map2TextureScale<string UIName = "map2TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map3Texture : DiffuseMap<string UIName = "map3Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map3TextureScale<string UIName = "map3TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map4Texture : DiffuseMap<string UIName = "map4Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map4TextureScale<string UIName = "map4TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map5Texture : DiffuseMap<string UIName = "map5Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map5TextureScale<string UIName = "map5TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map6Texture : DiffuseMap<string UIName = "map6Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map6TextureScale<string UIName = "map6TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
Texture2D map7Texture : DiffuseMap<string UIName = "map7Texture"; int Texcoord = 0; int MapChannel = 1;>;
float map7TextureScale<string UIName = "map7TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;

cbuffer everyFrame
{
	matrix World      : 		WORLD;
	matrix WorldViewProj : 		WORLDVIEWPROJ;
	matrix WorldView 	: 		WORLDVIEW;
	matrix Projection 	: 		PROJECTION;
};

struct VS_INPUT
{
	float3 Pos				: POSITION;
	float3 TVertex			: TEXCOORD0;
};

struct VS_OUTPUT
{
    float4 Pos				: SV_Position;
	float3 TVertex			: TEXCOORD0;
};

float4 blendLayers(float4 color1, float4 color0, float alpha)
{
	return color1 * alpha + color0 * (1.f - alpha);
};

VS_OUTPUT mainVS(VS_INPUT input)
{
	VS_OUTPUT output = (VS_OUTPUT)0;
	output.Pos = mul(float4(input.Pos, 1.), WorldViewProj);
	output.TVertex = input.TVertex;
    return output;
}

float4 mainFS(VS_OUTPUT input) : SV_Target
{
	float2 tc = input.TVertex.xy;
	float4 finalColor;
	float4 blend1Map = blend1Texture.Sample(textureSampler, tc);
	float4 blend2Map = blend2Texture.Sample(textureSampler, tc);
	finalColor = blendLayers(map1Texture.Sample(textureSampler, tc*map1TextureScale), map0Texture.Sample(textureSampler, tc*map0TextureScale), blend1Map.r);
	finalColor = blendLayers(map2Texture.Sample(textureSampler, tc*map2TextureScale), finalColor, blend1Map.g);
	finalColor = blendLayers(map3Texture.Sample(textureSampler, tc*map3TextureScale), finalColor, blend1Map.b);
	finalColor = blendLayers(map4Texture.Sample(textureSampler, tc*map4TextureScale), finalColor, blend1Map.a);
	finalColor = blendLayers(map5Texture.Sample(textureSampler, tc*map5TextureScale), finalColor, blend2Map.r);
	finalColor = blendLayers(map6Texture.Sample(textureSampler, tc*map6TextureScale), finalColor, blend2Map.g);
	finalColor = blendLayers(map7Texture.Sample(textureSampler, tc*map6TextureScale), finalColor, blend2Map.b);
    return finalColor;
}

RasterizerState DataCulling
{
	FillMode = SOLID;
	CullMode = FRONT;
	FrontCounterClockwise = false;
};

DepthStencilState EnableDepth
{
    DepthEnable = TRUE;
    DepthWriteMask = ALL;
};

technique10 DTerrain_Technique
{
    pass P0
    {
		SetRasterizerState(DataCulling);
		SetDepthStencilState( EnableDepth, 0 );	
		SetVertexShader( CompileShader( vs_4_0, mainVS()));
		SetGeometryShader(NULL);
		SetPixelShader( CompileShader( ps_4_0, mainFS()));
    }
}
