int DTerrain <string UIName = "DTerrain";> = 0;

texture blend1Texture : DiffuseMap<string UIName = "blend1Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D blend1TextureSampler = sampler_state{Texture = <blend1Texture>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
texture blend2Texture : DiffuseMap<string UIName = "blend2Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D blend2TextureSampler = sampler_state{Texture = <blend2Texture>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
texture map0Texture : DiffuseMap<string UIName = "map0Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map0TextureSampler = sampler_state{Texture = <map0Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map0TextureScale<string UIName = "map0TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map1Texture : DiffuseMap<string UIName = "map1Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map1TextureSampler = sampler_state{Texture = <map1Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map1TextureScale<string UIName = "map1TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map2Texture : DiffuseMap<string UIName = "map2Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map2TextureSampler = sampler_state{Texture = <map2Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map2TextureScale<string UIName = "map2TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map3Texture : DiffuseMap<string UIName = "map3Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map3TextureSampler = sampler_state{Texture = <map3Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map3TextureScale<string UIName = "map3TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map4Texture : DiffuseMap<string UIName = "map4Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map4TextureSampler = sampler_state{Texture = <map4Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map4TextureScale<string UIName = "map4TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map5Texture : DiffuseMap<string UIName = "map5Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map5TextureSampler = sampler_state{Texture = <map5Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map5TextureScale<string UIName = "map5TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map6Texture : DiffuseMap<string UIName = "map6Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map6TextureSampler = sampler_state{Texture = <map6Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map6TextureScale<string UIName = "map6TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;
texture map7Texture : DiffuseMap<string UIName = "map7Texture"; int Texcoord = 0; int MapChannel = 1;>;
sampler2D map7TextureSampler = sampler_state{Texture = <map7Texture>;MinFilter = Linear;MagFilter = Linear;MipFilter = Linear; ADDRESSU = WRAP; ADDRESSV = WRAP;};
float map7TextureScale<string UIName = "map7TextureScale";string UIType = "IntSpinner";float UIMin = 0.0f;float UIMax = 10000.0f;> = 1.0f;

float4x4 WorldViewProj	: WORLDVIEWPROJ;

struct VS_INPUT
{
	float3 Pos				: POSITION;
	float3 TVertex			: TEXCOORD0;
};

struct VS_OUTPUT
{
    float4 Pos				: POSITION;
	float3 TVertex			: TEXCOORD0;
};

float4 blendLayers(float4 color1, float4 color0, float alpha)
{
	return color1 * alpha + color0 * (1.f - alpha);
};

VS_OUTPUT mainVS(VS_INPUT input)
{
	VS_OUTPUT output = (VS_OUTPUT)0;
	output.Pos = mul(float4(input.Pos, 1.), WorldViewProj);
	output.TVertex = input.TVertex;
    return output;
}

float4 mainFS(VS_OUTPUT input) : COLOR
{
	float2 tc = input.TVertex.xy;
	float4 finalColor;
	float4 blend1Map = tex2D(blend1TextureSampler, tc);
	float4 blend2Map = tex2D(blend2TextureSampler, tc);
	finalColor = blendLayers(tex2D(map1TextureSampler, tc*map1TextureScale), tex2D(map0TextureSampler, tc*map0TextureScale), blend1Map.r);
	finalColor = blendLayers(tex2D(map2TextureSampler, tc*map2TextureScale), finalColor, blend1Map.g);
	finalColor = blendLayers(tex2D(map3TextureSampler, tc*map3TextureScale), finalColor, blend1Map.b);
	finalColor = blendLayers(tex2D(map4TextureSampler, tc*map4TextureScale), finalColor, blend1Map.a);
	finalColor = blendLayers(tex2D(map5TextureSampler, tc*map5TextureScale), finalColor, blend2Map.r);
	finalColor = blendLayers(tex2D(map6TextureSampler, tc*map6TextureScale), finalColor, blend2Map.g);
	finalColor = blendLayers(tex2D(map7TextureSampler, tc*map7TextureScale), finalColor, blend2Map.b);
    return finalColor;
}

technique DTerrain_Technique
{
    pass P0
    {
        CullMode = None;
        ShadeMode = Gouraud;
        VertexShader = compile vs_3_0 mainVS();
        PixelShader = compile ps_3_0 mainFS();
    }
}
